/** This is the header for the functions of program CUBETRANSPORT that are used to compute transportation distances by discretization **/

#ifndef DISCRETIZED_H_INCLUDED
#define DISCRETIZED_H_INCLUDED


/** FUNCTION PROTOTYPES **/

/* Function "bertsekas" computes the optimal transportation distance between two sets of points (seen as uniform probability distributions) "start" and "finish" of common size "n", the cost function from start[i] to finish[j] being "costfunc (i, j)", by Bertsekas' algorithm with precision "precision" */

double bertsekas (int n, struct double3 *start, struct double3 *finish, double costfunc (struct double3 thestart, struct double3 thefinish), double precision);

/* Function "sample" looks at an array "tosample" of "ntosam" point charges having total charge 1, and samples "nsam" independent points from it, stored in array "sampled" */

void sample (int ntosam, struct pointcharge *tosample, int nsam, struct double3 *sampled);

#endif // DISCRETIZED_H_INCLUDED
