#include "cubetransport.h"
#include "quadratic.h"

double qcost (double (***flow)[3], double ***charge0, double ***charge1)
{


  /** VARIABLE DECLARATIONS **/

  double cost; // Transportation cost
  int x, y, z; // Indices for locating a node in the grid
  double fx, fy, fz; // Transported charge along the x direction, resp. along y, resp. along z
  struct double3 dipole; // Dipole created by the charge displacement


  /** COMPUTING THE QUADRATIC COST **/

  cost = 0;
  METAFOR (x, y, z, nnn)
  {
    fx = (flowat (flow, x - 1, y, z, X) + flowat (flow, x, y, z, X)) / 2;
    fy = (flowat (flow, x, y - 1, z, Y) + flowat (flow, x, y, z, Y)) / 2;
    fz = (flowat (flow, x, y, z - 1, Z) + flowat (flow, x, y, z, Z)) / 2;
    dipole = lincomb (fx, fy, fz);
    cost += scalprod (dipole, dipole) / ((charge0[x][y][z] + charge1[x][y][z]) / 2);
  }
  ENDMETAFOR
  return cost;
}
