#include "cubetransport.h"
#include "discretized.h"

void sample (int ntosam, struct pointcharge *tosample, int nsam, struct double3 *sampled)
{


  /** VARIABLE DECLARATIONS **/

  int i; // Index for the entry we are reading in "tosample"
  int j; // Index for the entry we are writing in "sampled"
  double toscan; // Charge remaining to scan
  double mark; // Next value of toscan at which we will select a point


  /** INITIALIZATION **/

  mark = 1;
  toscan = 1;
  i = -1;


  /** LOOP FOR GETTING THE SAMPLED POINTS **/

  for (j = 0; j < nsam; ++j)
    {

      /* Updating "mark" randomly */

      mark *= pow (rand1 (), 1. / (nsam - j));

      /* Scanning the list to sample until finding the next sampled point */

      while (true)
        {
          if (toscan < mark)
            {
              sampled[j] = tosample[i].point;
              break;
            }
          else
            {
              if (i + 1 == ntosam) // Technical trick to avoid round-off issues
                {
                  toscan = 0;
                }
              else
                {
                  ++i;
                  toscan -= tosample[i].charge;
                }
            }
        }
    }
}
